﻿//////////////////////////////////////////////
// MaterialManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkAstraeus
{
	class Material ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Dll/DllDefines.h"

#include "MaterialType.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <string>
#include <string_view>
#include <unordered_map>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT MaterialManager final : public nkCommon::SingletonClass<MaterialManager>
	{
		friend class nkCommon::SingletonClass<MaterialManager> ;

		private :

			// Attributes
			// Memory
			std::unordered_map<std::string, Material*> _materials ;

		private :

			// Functions
			// Constructor, destructor
			MaterialManager () ;
			~MaterialManager () ;

		public :

			// Management
			Material* createOrRetrieve (const std::string_view& name, MATERIAL_TYPE type) ;
			Material* get (const std::string_view& name) ;
			Material* getByIndex (unsigned int id) ;
			void rename (const std::string_view& currentName, const std::string_view& newName) ;
			void erase (const std::string_view& name) ;
	} ;
}