﻿//////////////////////////////////////////////
// UbyteArrayWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua
{
	class DLL_ASTRAEUS_EXPORT UbyteArrayWrapper final
	{
		private :

			// Constructeur, destructeur
			UbyteArrayWrapper () = delete ;
			~UbyteArrayWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Constructor, destructor
			static nkScripts::OutputValue constructor (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;

			// Attributs
			static nkScripts::OutputValue getDataStr (void* data) ;
			static nkScripts::OutputValue getData (void* data) ;
			static nkScripts::OutputValue getSize (void* data) ;

			// Functions
			static nkScripts::OutputValue subView (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue fromString (const nkScripts::DataStack& stack) ;

			// Conversions
			static nkScripts::OutputValue readDouble (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue writeDouble (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue readString (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue writeString (const nkScripts::DataStack& stack) ;
	} ;
}