﻿//////////////////////////////////////////////
// VectorWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	class DLL_ASTRAEUS_EXPORT VectorWrapper final
	{
		private :

			// Constructeur, destructeur
			VectorWrapper () = delete ;
			~VectorWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Construction / destruction
			static void* constructor (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;
			static nkScripts::OutputValue newVec2 (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue newVec3 (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue newVec4 (const nkScripts::DataStack& stack) ;
			// Getters
			static nkScripts::OutputValue getX (void* vector) ;
			static nkScripts::OutputValue getY (void* vector) ;
			static nkScripts::OutputValue getZ (void* vector) ;
			static nkScripts::OutputValue getW (void* vector) ;
			// Setters
			static void setX (const nkScripts::DataStack& stack) ;
			static void setY (const nkScripts::DataStack& stack) ;
			static void setZ (const nkScripts::DataStack& stack) ;
			static void setW (const nkScripts::DataStack& stack) ;
			// Distances
			static nkScripts::OutputValue getDistance (const nkScripts::DataStack& stack) ;
			// Conversion
			static nkScripts::OutputValue toString (const nkScripts::DataStack& stack) ;
			// Opérations
			static nkScripts::OutputValue add (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue sub (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue mul (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue div (const nkScripts::DataStack& stack) ;
			// Comparaisons
			static nkScripts::OutputValue eq (const nkScripts::DataStack& stack) ;
	} ;
}