﻿//////////////////////////////////////////////
// LuaThread.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkAstraeus::lua::nkTasksWrap
{
	class LuaTask ;
}

namespace nkScripts
{
	class Environment ;
	class Script ;
	class ScriptObjectReference ;
}

namespace nkTasks
{
	class Thread ;
}

/// Includes ---------------------------------

// nkTasks
#include <NilkinsTasks/Threads/ThreadSubmittedWork.h>

// Standards
#include <unordered_map>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkTasksWrap
{
	class LuaThread final
	{
		private :

			// Thread nkTasks
			nkTasks::Thread* _thread ;
			// Environnement à part
			nkScripts::Environment* _env ;

			// Les références sur les tasks actives
			std::unordered_map<LuaTask*, nkScripts::ScriptObjectReference> _taskRefs ;

		public :

			// Constructeur, destructeur
			LuaThread () ;
			~LuaThread () ;

			// Manipulations
			nkTasks::ThreadSubmittedWork addTask (LuaTask* task, const nkScripts::ScriptObjectReference& luaRef) ;
			void releaseTaskRef (LuaTask* task) ;
			void run () ;
			void askAbort () ;
			void join () ;
			void askAbortAndJoin () ;

			// Utils
			void runScript (nkScripts::Script* script) ;
	} ;
}