﻿//////////////////////////////////////////////
// MeshLoadQuery.h
//
//////////////////////////////////////////////

/// Macros / Defines -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Mesh ;
}

/// Includes ---------------------------------
	
// nkGraphics
#include "../../Dll/DllDefines.h"

// Standards
#include <functional>
#include <string>

/// Class ------------------------------------

namespace nkGraphics
{
	// Classe
	class DLL_GRAPHICS_EXPORT MeshLoadQuery
	{
		private :

			// Path du fichier
			std::string _path ;
			std::string _fromDataPath ;
			bool _isDeclFile ;
			// Nom du mesh à créer
			std::string _meshName ;

			// Si on load ou on attend
			bool _autoLoad ;
			// Si on fait en async
			bool _asynchronous ;

			// La fonction callback si asynchrone
			// Appelé depuis thread graphique
			std::function<void(Mesh*)> _asyncCallback ;

			// Si on génère des données bonus
			bool _generateTangent ;
			bool _generateBinormal ;

		public :

			// Constructor, destructor
			MeshLoadQuery () ;
			MeshLoadQuery (const MeshLoadQuery& other) ;
			~MeshLoadQuery () ;

			// Getters
			std::string_view getPath () const ;
			std::string_view getFromDataPath () const ;
			bool isDeclFile () const ;
			std::string_view getMeshName () const ;
			bool getAutoLoad () const ;
			bool getAsynchronous () const ;
			std::function<void(Mesh*)> getAsyncCallback () const ;
			bool getGenerateTangent () const ;
			bool getGenerateBinormal () const ;

			// Setters
			void setPath (const std::string_view& value) ;
			void setFromDataPath (const std::string_view& value) ;
			void setIsDeclFile (bool value) ;
			void setMeshName (const std::string_view& value) ;
			void setAutoLoad (bool value) ;
			void setAsynchronous (bool value) ;
			void setAsyncCallback (std::function<void(Mesh*)> value) ;
			void setGenerateTangent (bool value) ;
			void setGenerateBinormal (bool value) ;
	} ;
}