﻿//////////////////////////////////////////////
// ImageData.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "DxDefinesWrapper.h"

#include "../Dll/DllDefines.h"

// nkMaths
#include <NilkinsMaths/Algebra/Vector.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ImageData
	{
		public :

			unsigned char* _data = nullptr ;

			unsigned int _width = 0 ;
			unsigned int _height = 0 ;
			unsigned int _rowByteSize = 0 ;

			FORMAT _imageFormat = R8G8B8A8_UNORM ;

		public :

			// Constructeur, destructeur
			ImageData () ;
			ImageData (ImageData&& other) ;
			~ImageData () ;

			// Getters
			nkMaths::Vector getPixelAt (unsigned int xPix, unsigned int yPix) ;

			// Setters
			void setPixelAt (unsigned int xPix, unsigned int yPix, const nkMaths::Vector& color) ;

			// Export
			bool exportToFileAsBmp (const char* path) ;

			// Opérateurs
			ImageData& operator= (ImageData&& other) ;
	} ; 
}