﻿//////////////////////////////////////////////
// GraphicsWindow.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

typedef struct HWND__* HWND ;

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

#include "../Inputs/CallbackRepository.h"

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT GraphicsWindow : public Component
	{
		protected :
		
			// Attributes
			// Callbacks
			closeCallback _closeCallback ;
			resizeCallback _resizeCallback ;
			mouseLeaveCallback _mouseLeaveCallback ;
		
		public :
		
			// Constructeur, destructeur
			GraphicsWindow () ;
			~GraphicsWindow () ;
			
			// Getters
			virtual HWND getHwnd () const ;

			// Setters
			void setCloseCallback (const closeCallback& callback) ;
			void setResizeCallback (const resizeCallback& callback) ;
			void setMouseLeaveCallback (const mouseLeaveCallback& callback) ;

			// Maximisation
			virtual void maximize (bool val) = 0 ;

			// Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}